package comblock;

import java.io.FileOutputStream;
import java.io.IOException;

public class UsbExample {
	

	/*******************************************************************************/
	// This method writes received data from USB to a file
	public void receiveBinaryFile(int noOfBytesToReceive,
			FileOutputStream outputStreamBinary) {
		int returnValue = 0;
		int bufferSize = Math.min(4096, noOfBytesToReceive);
		int noOfBytesSaved = 0;
		int noOfBytesReadCurrentIteration = 0;
		boolean flushBuffer = false;
		byte[] readByte = new byte[bufferSize];


		while ((noOfBytesSaved < noOfBytesToReceive) && (returnValue >= 0)) {
			if ((noOfBytesToReceive - noOfBytesSaved) < bufferSize) {
				// last few bytes.
				bufferSize = noOfBytesToReceive - noOfBytesSaved;
					noOfBytesReadCurrentIteration = Comms.uSB.Read(2,
							bufferSize, readByte);
					if(noOfBytesReadCurrentIteration == -19){
						// timeout. Nothing to read at this time. Try again later
						noOfBytesReadCurrentIteration = 0;
					} else if (noOfBytesReadCurrentIteration < 0) {
						returnValue = -2;
						break;
					}
			} else {
					noOfBytesReadCurrentIteration = Comms.uSB.Read(2,
							bufferSize, readByte);
					if(noOfBytesReadCurrentIteration == -19){
						// timeout. Nothing to read at this time. Try again later
						noOfBytesReadCurrentIteration = 0;
					} else if (noOfBytesReadCurrentIteration < 0) {
						returnValue = -2;
						break;
					}
			}
			if (returnValue >= 0) {
				// Save the file in binary format
				noOfBytesSaved += noOfBytesReadCurrentIteration;
				if (noOfBytesSaved == noOfBytesToReceive) {
					flushBuffer = true;
				} else {
					flushBuffer = false;
				}
				try {
					outputStreamBinary.write(readByte, 0,
							noOfBytesReadCurrentIteration);
					if (flushBuffer) {
						outputStreamBinary.flush();
					}
				} catch (IOException e) {
					System.err.println(e);
					returnValue = -2;
					break;
				}
			}
		}


		return;
	}
}
